<?php
namespace Home\Controller;
use \Think\Controller;
ini_set('soap.wsdl_cache_enabled','0');//关闭缓存
class CreateSoapController extends Controller {
    public function _initialize()
    {
        $this->creatWsdl();
    }

    public function index()
    {
        // 获取配置文件中写的wsdl文件存放目录
        $path = C('WSDL_PATH');
        $name = C('HIS_NAME');
        if(file_exists($path.$name.".wsdl"))
        {
            // 实例化SoapServer服务
            // 第一个参数是刚才生成的wsdl文件的地址
            // 第二个是soap版本
            import('Vendor.'.$name);
            $server = new \SoapServer($path.$name.".wsdl", array('soap_version' => SOAP_1_2));
            // 注册对应类的方法
            $server->setClass($name);
            //处理请求
            $server->handle();
        }
    }

    private function creatWsdl()
    {
        // 获取配置文件中写的wsdl文件存放目录
        $path = C('WSDL_PATH');
        $name = C('HIS_NAME');
        // 判断对应目录是否存在，没有则创建
        if(!is_dir($path)){
            mkdir($path);
        }
        //判断wsdl文件是否存在，没有则创建
        //这里是以当前类名字来命名的wsdl文件，所以用到tp的CONTROLLER_NAME
        if (file_exists($path.$name.".wsdl")){
            @unlink($path.$name.".wsdl");
        }
        // 引入SoapDiscovery.class.php，我把它放在ThinkPHP/Library/Verndor目录下
        import('Vendor.SoapDiscovery');
        // 这里传入第一个参数是当前类的路径（生成的wsdl文件以当前类命名）
        // 第二个参数是服务名字（可根据具体用处命名）
        // 第三个是wsdl文件存放的地址，不传默认是tp的根目录（在SoapDiscovery.class.php中定义的）
        import('Vendor.'.$name);
        $disco = new \SoapDiscovery($name,'soap',$path);
        // 生成wsdl文件
        $disco->getWSDL();
    }
}